#!/bin/bash
set -e
echo "$0 preparation script"
pwd

export LIB_DIR=${PWD}/lib

echo "Cleaning ..."
make clean

echo "Running tests now pwd ${LIB_DIR}"
#CFLAGS="${CFLAGS} -g -Wall -g -O0 -fprofile-arcs -ftest-coverage --coverage" CONFIG_IEEE1905_ALME_OVER_UBUS=y make
CFLAGS="-D_GNU_SOURCE -g -Wall -O0" CONFIG_IEEE1905_ALME_OVER_UBUS=y make
ret=$?
if [ "$ret" -ne 0 ]; then
	echo "Compilation failed!"
	exit ${ret}
fi

# installing dependent library
make install

supervisorctl status all
supervisorctl update
supervisorctl restart all
sleep 3
supervisorctl status all

# run API validation
ubus-api-validator -d ./test/api/json/ > ./api-result.log
ret=$?

supervisorctl stop all
supervisorctl status

cp ./memory-report.xml ./api-test-memory-report.xml
tap-junit --input ./api-result.log --output report
date +%s > timestamp.log

echo "Checking memory leaks..."
grep -q "Leak_DefinitelyLost" memory-report.xml
if [ "$?" -eq 0 ]; then
	ret=2
fi

echo "$0 exit status ${ret}"
exit ${ret}
