#!/bin/sh -eu


PCAP_PATH="/home/ieee1905/test/pcap"
DADDR=`ip add show dev eth0|grep ether|awk '{printf $2}'`

function replay()
{
	echo "Replaying ${1}.pcap"
	tcpreplay -q --intf1=eth0 ${PCAP_PATH}/${1}.pcap >/dev/null
}
function modify_replay()
{
	pcap_file=${1}.pcap
	echo "Modify ${pcap_file} before replay"
	tcprewrite --enet-dmac=${DADDR} --infile="${PCAP_PATH}/${pcap_file}" --outfile=/tmp/replay.pcap
	echo "Replaying packet"
	tcpreplay -q --intf1=eth0 /tmp/replay.pcap >/dev/null
	rm /tmp/replay.pcap
}


while read -r line; do
    case "${line}" in
        *start) 
		echo "TCPREPLAY will now run, received line: ${line}"
		modify_replay topology_discover
		modify_replay autoconfig_search
		modify_replay topology_query
		modify_replay topology_discover
		modify_replay topology_query
		modify_replay topology_response
		modify_replay topology_discover
		modify_replay higher_layer_query
		modify_replay link_metric_query
		modify_replay higher_layer_response
		modify_replay link_metric_response
		  ;;
        *) echo "Invalid input: ${line}" ;;
    esac
done


