#!/bin/bash

echo "install dependencies"

pwd

function exec_cmd()
{
	echo "executing $@"
	$@ >/dev/null 2>&1

	if [ $? -ne 0 ]; then
		echo "Failed to execute $@"
		exit 1
	fi
}

mkdir -p /opt/dev/
# install packages
exec_cmd apt update
exec_cmd apt install -y iproute2 tcpreplay netcat-openbsd tcpdump

# install libraries from source
cd /opt/dev
rm -fr easy-soc-libs
exec_cmd git clone --depth 1 -b devel https://dev.iopsys.eu/iopsys/easy-soc-libs.git
cd easy-soc-libs

cd libeasy
exec_cmd make CFLAGS+="-I/usr/include/libnl3"
mkdir -p /usr/include/easy
cp easy.h event.h utils.h debug.h if_utils.h /usr/include/easy
cp -a libeasy*.so* /usr/lib

cd ../libwifi
exec_cmd make PLATFORM=TEST
cp wifi.h /usr/include
cp -a libwifi-6.so* /usr/lib

cd ../libdsl
exec_cmd make PLATFORM=TEST
cp common.h xdsl.h xtm.h /usr/include
cp -a libdsl*.so* /usr/lib
sudo ldconfig
