#!/bin/bash
set -e
echo "preparation script"
pwd

export LIB_DIR=${PWD}/lib
export LD_LIBRARY_PATH=${LIB_DIR}

echo "Cleaning ..."
make clean
make -C test/cmocka clean

echo "Creating library"
LDFLAGS="${LDFLAGS}" CFLAGS="${CFLAGS} -g -Wall -g -O0 -fPIC" CONFIG_IEEE1905_ALME_OVER_UBUS=y make unit-test
#LDFLAGS="${LDFLAGS} --coverage" CFLAGS="${CFLAGS} -g -Wall -g -O0 -fprofile-arcs -ftest-coverage -fPIC" CONFIG_IEEE1905_ALME_OVER_UBUS=y make unit-test

make install
ldconfig

echo "Running tests now pwd ${LIB_DIR}"
make -C test/cmocka unit-test
ret=$?

#report part
#GitLab-CI output
#gcovr -r ./src/
# Artefact
#gcovr -r ./src/ --xml -o ./unit-test-coverage.xml
date +%s > timestamp.log

echo "$0 Return status ${ret}"
exit ${ret}
