#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <cmocka.h>
#include <libubus.h>
#include <libubox/blobmsg_json.h>
#include <libubox/blobmsg.h>
#include <json-c/json.h>
#include "1905_ubus.h"

extern int al_init_start();
extern void al_cleanup();

struct test_ctx {
        struct blob_buf bb;
        struct ubus_object ieee1905;
        FILE *fp;
};

static int group_setup(void **state)
{
        struct test_ctx *ctx = calloc(1, sizeof(struct test_ctx));
        if (!ctx)
                return -1;

	al_init_start();

        //remove("/tmp/test.log");
        ctx->ieee1905.name = "ieee1905";
        memset(&ctx->bb, 0, sizeof(struct blob_buf));
        *state = ctx;
        return 0;
}

static int setup(void **state)
{
        struct test_ctx *ctx = (struct test_ctx *) *state;
        remove("/tmp/test.log");
        blob_buf_init(&ctx->bb, 0);
        return 0;
}

static int group_teardown(void **state)
{
        struct test_ctx *ctx = (struct test_ctx *) *state;

        blob_buf_free(&ctx->bb);
        free(ctx);
        //remove("/tmp/test.log");
	al_cleanup();
        return 0;
}

static void test_api_ieee1905_info(void **state)
{
        struct test_ctx *ctx = (struct test_ctx *) *state;
        struct blob_buf *bb = &ctx->bb;
        struct ubus_object *obj = &ctx->ieee1905;
        struct json_object *jobj, *tmp, *array_obj, *array_index_obj;

        ieee1905_all_interface_info(NULL, obj, NULL, NULL, NULL);
        jobj = json_object_from_file("/tmp/test.log");

        assert_non_null(jobj);

  //      array_obj = json_object_object_get(jobj, "data");
    //    array_index_obj = json_object_array_get_idx(array_obj, 0);

      //  tmp = json_object_object_get(array_index_obj, "wfa-dataelements:Network");

        //assert_string_equal(json_object_get_string(tmp), "Device.Users.User.1.");


        json_object_put(jobj);
        return;
}

int ubus_send_reply(struct ubus_context *ctx, struct ubus_request_data *req,
                    struct blob_attr *msg)
{
        char *str;
        FILE *fp;

        fp = fopen("/tmp/test.log", "w");
        if (!fp) {
                printf("failed to open file\n");
                return -1;
        }

        if (!msg)
                return -1;

        str = blobmsg_format_json_indent(msg, true, -1);
        fprintf(fp, "%s", str);

        fclose(fp);
        free(str);
        return 0;
}

int main(void)
{
        const struct CMUnitTest tests[] = {
                cmocka_unit_test_setup(test_api_ieee1905_info, setup)
        };

        return cmocka_run_group_tests(tests, group_setup, group_teardown);
}
